;
; MagicalPrince UnOfficialInstaller
;

; 2008/03/30 ver.0.01 uHHdL6c/Xo 
; 2008/03/30 ver.0.01 ID:nKolgdIh0 W[݂̂œ삷悤ɉ
; 2008/03/30 ver.0.03 ID:nKolgdIh0 ACXg[Ɍxǉ

; Compiler Flags
SetCompressor /FINAL zlib
SetCompress off

!include FileFunc.nsh
!insertmacro GetDrives

; Installer Version
!define VERSION "0.0.3"

; Language
LoadLanguageFile "${NSISDIR}\Contrib\Language files\Japanese.nlf"

; App Name
;Name "MagicalPrince UnOfficialInstaller ${VERSION}"
Name "܂vX"

; Installer EXE file name
OutFile "MagicalPrinceInstallerUO.EXE"

; Default install path
InstallDir "$PROGRAMFILES\ROLL"
InstallDirRegKey HKLM "Software\ROLL\MagicalPrince" "instpath"

; Request application privileges for WinVista
RequestExecutionLevel admin

; Install Pages
Page components
Page directory
Page instfiles

; UnInstall Pages
UninstPage uninstConfirm
UninstPage instfiles

Var SrcDrv
Var IDir

; InstallSection
Section "܂vX{ (K{)"
	; This section is required.
	SectionIn RO

	; Get SrcDrv
	retry:
	StrCpy "$SrcDrv" "ERR_DISC_NOT_FOUND"
	${GetDrives} "CDROM" "CheckDrive"
	StrCmpS $SrcDrv "ERR_DISC_NOT_FOUND" 0 +3
		MessageBox MB_RETRYCANCEL "܂vX̃fBXN܂" IDRETRY retry
		Abort "CXg[𒆎~܂"

	; fBXNõeXg͂Ŏ~߂
;	Abort "͂܂"

	; Set output path to the installation directory
	ClearErrors
	SetOutPath "$INSTDIR\܂vX"
	IfErrors 0 +5
		MessageBox MB_OK "CXg[fBNgi$INSTDIR\܂vXj쐬ł܂ł"
		RMDir "$INSTDIR\܂vX"
		RMDir "$INSTDIR"
		Abort "CXg[𒆎~܂"
	
	; Copy files there
	ClearErrors
	CopyFiles "$SrcDrv\܂\*.*" "$INSTDIR\܂vX"
	IfErrors 0 +6
		MessageBox MB_OK "CXg[Ƃ[Uɂ蒆fꂽACXg[ƒɃG[܂"
		Delete "$INSTDIR\܂vX\*.*"
		RMDir /r "$INSTDIR\܂vX"
		RMDir "$INSTDIR"
		Abort "CXg[𒆎~܂"
	; Write the inst path into the regkey
	WriteRegStr HKLM "Software\ROLL\MagicalPrince" "instpath" "$INSTDIR"
	WriteRegStr HKLM "Software\ROLL\MagicalPrince" "path" "$INSTDIR\܂vX"
	WriteRegDWORD HKLM "Software\ROLL\MagicalPrince" "verexe" 0
	WriteRegDWORD HKLM "Software\ROLL\MagicalPrince" "verscr" 0
	WriteRegDWORD HKLM "Software\ROLL\MagicalPrince" "vergrp" 0
	WriteRegDWORD HKLM "Software\ROLL\MagicalPrince" "vervc" 0
	WriteRegDWORD HKLM "Software\ROLL\MagicalPrince" "versnd" 0
	WriteRegDWORD HKLM "Software\ROLL\MagicalPrince" "verse" 0
	
	; Prepare UnInstall
	WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\ROLL_MagicalPrince" "DisplayName" "܂vX"
	WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\ROLL_MagicalPrince" "UninstallString" '"$INSTDIR\܂vX\uninst.exe"'
	WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\ROLL_MagicalPrince" "NoModify" 1
	WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\ROLL_MagicalPrince" "NoRepair" 1
	WriteUninstaller "$INSTDIR\܂vX\uninst.exe"
SectionEnd

Function CheckDrive
;	MessageBox MB_OK "$9  ($8 Drive)"
;	MessageBox MB_OK "$9܂\܂遙XN[.exe"
	IfFileExists $9܂\܂遙XN[.exe 0 +3
		StrCpy $SrcDrv $9
		StrCpy $0 StopGetDrives
	Push $0
FunctionEnd

Section "X^[gj[ɃV[gJbg쐬"
	SetShellVarContext all
	CreateDirectory "$SMPROGRAMS\ROLL\܂vX"
	CreateShortCut "$SMPROGRAMS\ROLL\܂vX\܂vX.lnk" "$INSTDIR\܂vX\܂遙XN[.exe" "" "$INSTDIR\܂vX\܂遙XN[.exe" "" SW_SHOWNORMAL
	CreateShortCut "$SMPROGRAMS\ROLL\܂vX\ACXg[.lnk" "$INSTDIR\܂vX\uninst.exe" "" "$INSTDIR\܂vX\uninst.exe" 0
SectionEnd

Section /o "fXNgbvɃV[gJbg쐬"
	SetShellVarContext current
	CreateShortCut "$DESKTOP\܂vX.lnk" "$INSTDIR\܂vX\܂遙XN[.exe" "" "$INSTDIR\܂vX\܂遙XN[.exe" "" SW_SHOWNORMAL
SectionEnd




; UnInstall Section
Section "un.ACXg["

	MessageBox MB_OKCANCEL "ACXg[ $IDir\܂vX ׂ̉č폜܂BZ[uf[^폜܂B͂낵łH" IDOK ready_to_del IDCANCEL no_del

	no_del:
	Abort "ACXg[𒆎~܂"

	ready_to_del:
	ClearErrors
	ReadRegStr $IDir HKLM "Software\ROLL\MagicalPrince" "instpath"
	DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\ROLL_MagicalPrince"
	DeleteRegKey HKLM "Software\ROLL\MagicalPrince"
	DeleteRegKey /ifempty HKLM "Software\ROLL"

	ClearErrors
	SetShellVarContext all
	IfFileExists "$SMPROGRAMS\ROLL\܂vX\܂vX.lnk" 0 +2
		Delete "$SMPROGRAMS\ROLL\܂vX\܂vX.lnk"
	IfFileExists "$SMPROGRAMS\ROLL\܂vX\ACXg[.lnk" 0 +2
		Delete "$SMPROGRAMS\ROLL\܂vX\ACXg[.lnk"
	ClearErrors
	RMDir "$SMPROGRAMS\ROLL\܂vX"
	ClearErrors
	RMDir "$SMPROGRAMS\ROLL"

	ClearErrors
	SetShellVarContext current
	IfFileExists "$DESKTOP\܂vX.lnk" 0 +2
		Delete "$DESKTOP\܂vX.lnk"

	ClearErrors
	Delete "$IDir\܂vX\*.*"
	SetOutPath "$TEMP"
	RMDir /r "$IDir\܂vX"
	RMDir "$IDir"

SectionEnd



